package nc.bs.pub.action;

import nc.bs.framework.common.NCLocator;
import nc.bs.pub.compiler.AbstractCompiler2;
import nc.itf.pu.m25.IInvoiceApprove;
import nc.itf.th.IThOcrService;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pu.m25.env.InvoiceUIToBSEnv;
import nc.vo.pu.m25.pub.InvoiceEnvExtractUtil;
import nc.vo.pub.BusinessException;
import nc.vo.pub.compiler.PfParameterVO;
import nc.vo.uap.pf.PFBusinessException;

public class N_25_APPROVE extends AbstractCompiler2 {
	public String getCodeRemark() {
		return "\t\n      nc.vo.pu.m25.entity.InvoiceVO inObject  =(nc.vo.pu.m25.entity.InvoiceVO) getVo();\n      \n      setParameter(\"INVO\", inObject);\n\treturn null;\n";
	}

	public Object runComClass(PfParameterVO vo) throws BusinessException {
		try {
			super.m_tmpVo = vo;
			Object retValue = null;
			InvoiceVO[] vos = (InvoiceVO[]) ((InvoiceVO[]) this.getVos());
			InvoiceUIToBSEnv[] envs = InvoiceEnvExtractUtil.getEnvs(vo);
			retValue = ((IInvoiceApprove) NCLocator.getInstance().lookup(IInvoiceApprove.class)).approve(vos, this,
					envs);
			String status = vo.m_workFlow.getApproveresult();
			NCLocator.getInstance().lookup(IThOcrService.class).UpdateInvoiceStatus(status, vos);
			return retValue;
		} catch (Exception var5) {
			if (var5 instanceof BusinessException) {
				throw (BusinessException) var5;
			} else {
				throw new PFBusinessException(var5.getMessage(), var5);
			}
		}
	}
}