package nc.itf.th;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.httpclient.HttpException;

import com.alibaba.fastjson.JSONObject;

import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pub.BusinessException;
import nc.vo.th.ocr.OCRInvoiceVO;
import net.sf.json.JSONString;

/**
 * OCRӿ
 * @author Administrator
 *
 */

public interface IThOcrService {
	/**
	 * 
	 * ȡtoken
	 */
	public String getToken(String billmaker) throws Exception;
	
	/**
	 * ϴƱ
	 */
	public String uploadInvoice(String token,String vdef17,String invoicename) throws Exception;
	
	/**
	 * OCRʶ
	 */
	public String ocrIdentification(String token,String data) throws Exception;
	
	
	/**
	 * OCRʶݱݿ
	 */
	public void insertOCRdataInfo(ArrayList<OCRInvoiceVO> vos) throws BusinessException;
	

	
	/**
	 * Ʊ浽ļ
	 */
	public String saveUploadFile(String vdef17,String fileName,byte[] bytes) throws Exception;
	
	
	/**
	 * ɾhomeӦķƱ
	 */
	public Boolean deleteFile(String filepath) ;
	
	
	
	/**
	 * ɾ̫ĳԶ嵵ͣ
	 */
	public  DefdocVO[]  enablestateDate(String filepath,String[] filname)  throws BusinessException;
	
	
	
	/**
	 * ȡhome·
	 */
	public  String  getNCHomePath();
	
	
	/**
	 * ȡ"+vdef17+"ļзƱ
	 */
	
	public  List<String>  getInvoiceInfo(String vdef17);
	
	/**
	 * ޸ķƱƷƱ״̬
	 * @param status  Ʊ״̬
	 * @param vos  Ʊaggvo
	 */
	public void UpdateInvoiceStatus(String status,InvoiceVO[] vos) throws Exception;
	
	/**
	 * Ʊα
	 */
	public void InvoiceCheck(String token,String fid) throws Exception;
	
	
	/**
	 * ӷƱƻȡƱ
	 */
	public JSONObject SelectORCInvoice(String token) throws Exception;
	
}
