package nc.ui.pu.m25.editor.card.afteredit.body;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pu.pub.editor.card.listener.ICardBodyAfterEditEventListener;
import nc.ui.pub.beans.UIRefPane;
import nc.ui.pub.beans.constenum.DefaultConstEnum;
import nc.ui.pubapp.uif2app.event.card.CardBodyAfterEditEvent;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class OcrRefaft implements ICardBodyAfterEditEventListener{
	
	public IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	@Override
	public void afterEdit(CardBodyAfterEditEvent arg0) {
		
		UIRefPane ref=(UIRefPane) arg0.getBillCardPanel().getBodyItem("OCR").getComponent();
		String[] pks = ref.getRefPKs();
		StringBuffer sbf = new StringBuffer();
		// PK
		if (pks == null || pks.length <= 0) {
			return;
		}else {
			for (int i = 0; i < pks.length; i++) {
				sbf.append(pks[i]+",");
			}	
		}
		
		UFDouble SumAmount = UFDouble.ZERO_DBL;//˰
		UFDouble SumTotal = UFDouble.ZERO_DBL;//˰ϼ
		UFDouble SumTax =UFDouble.ZERO_DBL;//˰
		String shuilv = "";//¼һ˰ʣͺжԱȣͬ򱨴
		Object shuilvpk = "";
		if(pks.length > 1){			
			for(int j = 0;j < pks.length;j++){
				String pk = pks[j];
				String qrysql = "select * from bd_defdoc where dr=0 and pk_defdoc = '"+pk+"'";
				DefdocVO defdocvo;
				try {
					defdocvo = (DefdocVO) iuap.executeQuery(qrysql, new BeanProcessor(DefdocVO.class));
					Object shortname6 = defdocvo.getShortname6();
						if(shortname6 == null){
							ExceptionUtils.wrappBusinessException("ѡƱ˰Ϊգܱ棡");
							return;
						}
					if(j == 0 && shortname6 != null){
						shuilv = shortname6.toString();
					}
						if(j != 0 && !shortname6.toString().equals(shuilv)){
							ExceptionUtils.wrappBusinessException("ѡƱ˰ʲܱͬ棡");
							return;
						}
					
				} catch (BusinessException e) {
					// TODO Զɵ catch 
					ExceptionUtils.wrappBusinessException(e.getMessage());
				}
			}
		}
		
		
		for(int i = 0;i < pks.length;i++){
			String pk = pks[i];
			String qrysql = "select * from bd_defdoc where dr=0 and pk_defdoc = '"+pk+"'";
			DefdocVO defdocvo;
			try {
				defdocvo = (DefdocVO) iuap.executeQuery(qrysql, new BeanProcessor(DefdocVO.class));
				String qryshuilv = "select pk_taxcode from bd_taxrate where nvl(dr,0) = 0 and pk_taxcode not in (select pk_taxcode from bd_taxcode where code = '0') and taxrate = '"+defdocvo.getShortname6()+"'";
				try {
					shuilvpk = iuap.executeQuery(qryshuilv, new ColumnProcessor());
					if(shuilvpk == null){
						ExceptionUtils.wrappBusinessException("˰ûжӦ˰룬飡");
						return;
					}
				} catch (BusinessException e1) {
					// TODO Զɵ catch 
					ExceptionUtils.wrappBusinessException(e1.getMessage());
				}
			//	arg0.getBillCardPanel().setHeadItem("vbillcode", defdocvo.getName());//Ʊ
				arg0.getBillCardPanel().setHeadItem("vdef19", defdocvo.getName4());//Ʊ
//					arg0.getBillCardPanel().setHeadItem("dbilldate", new UFDate(defdocvo.getShortname4()));//Ʊ
				arg0.getBillCardPanel().setBodyValueAt(defdocvo.getShortname5(), arg0.getRow(), "vbdef17");//Ʊ
				arg0.getBillCardPanel().setBodyValueAt(defdocvo.getShortname6(), arg0.getRow(), "ntaxrate");//˰
				arg0.getBillCardPanel().setBodyValueAt(shuilvpk, arg0.getRow(), "ctaxcodeid");//˰
				Object shortname = defdocvo.getShortname();
				if(shortname != null && shortname.toString() != ""){
					SumAmount = SumAmount.add(new UFDouble(shortname.toString()));
				}
				Object shortname2 = defdocvo.getShortname2();
				if(shortname2 != null && shortname2.toString() != ""){
					SumTotal = SumTotal.add(new UFDouble(shortname2.toString()));
				}
				Object shortname3 = defdocvo.getShortname3();
				if(shortname3 != null && shortname3.toString() != ""){
					SumTax = SumTax.add(new UFDouble(shortname3.toString()));
				}
			} catch (BusinessException e) {
				// TODO Զɵ catch 
				ExceptionUtils.wrappBusinessException(e.getMessage());
			}
		}
		arg0.getBillCardPanel().setBodyValueAt(1, arg0.getRow(), "nastnum");//
		arg0.getBillCardPanel().setBodyValueAt(1, arg0.getRow(), "nnum");//
		arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nastorigprice");//˰
		arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nastprice");//˰
		arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "norigmny");//˰
		arg0.getBillCardPanel().setBodyValueAt(SumAmount, arg0.getRow(), "nmny");//˰
		arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "nastorigtaxprice");//˰
		arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "nasttaxprice");//Һ˰
		arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "norigtaxmny");//˰ϼ
		arg0.getBillCardPanel().setBodyValueAt(SumTotal, arg0.getRow(), "ntaxmny");//Ҽ˰ϼ
		arg0.getBillCardPanel().setBodyValueAt(SumTax, arg0.getRow(), "ntax");//˰
		
		
		
		//PK
	//	ref.setPKs(pks);
		DefaultConstEnum refEnumxz = new DefaultConstEnum(sbf.toString().substring(0, sbf.toString().length()-1), ref.getRefShowName());
		DefaultConstEnum refEnum = new DefaultConstEnum("1001ZZ1000000097LQJ2", "ƱϢѸֵ");///ĬֵƱϢѸֵ
		arg0.getBillCardPanel().setBodyValueAt(refEnum, arg0.getRow(), "OCR");//Ĭ
		arg0.getBillCardPanel().setBodyValueAt(sbf.toString().substring(0, sbf.toString().length()-1), arg0.getRow(), "vbdef20");//
		arg0.getBillCardPanel().setBodyValueAt(refEnumxz, arg0.getRow(), "vbdef16");//ʾ

   }

}