package nc.bs.ic.base;

import nc.bs.framework.common.NCLocator;
import nc.impl.pubapp.pattern.rule.IRule;
import nc.itf.th.IThOcrService;
import nc.vo.pu.m25.entity.InvoiceVO;
import nc.vo.pubapp.pattern.exception.ExceptionUtils;

public class InvoiceAfterSubmitEvent  implements IRule<InvoiceVO>{

	@Override
	public void process(InvoiceVO[] vos) {
		IThOcrService  iThOcrService=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
		try {
			iThOcrService.UpdateInvoiceStatus("T", vos);
		} catch (Exception e) {
			e.printStackTrace();
			ExceptionUtils.wrappBusinessException(e.getMessage());
		}
	}

}
